/**
 * initApp handles setting up UI event listeners and registering Firebase auth listeners:
 *  - firebase.auth().onAuthStateChanged: This listener is called when the user is signed in or
 *    out, and that is where we update the UI.
 */

 let email;
 let uid;
 
 function initApp() {
     // Listening for auth state changes.
     // [START authstatelistener]
     firebase.auth().onAuthStateChanged(function (user) {
         if (user) {
             // User is signed in.
 
             email = user.email;
             let emailVerified = user.emailVerified;
             uid = user.uid;
             let providerData = user.providerData;
 
             // console.log(email)
             let db = firebase.firestore();
 
 
             let docRef = db.collection("admins").doc(uid);
 
             docRef.get().then(function (doc) {
                 if (doc.exists) {
                     console.log("Document data:", doc.data());
                     let type = doc.data().typeId;
                     let name = doc.data().name;
                     if (type === 1) {
                    
                         document.getElementById('proName').innerText = name;
                     }else if(type === 2){
                         
                     } else if (type === 3) {
                         
                     }
 
 
                 } else {
                    Swal.fire({
                        icon: 'error',
                        title: 'Oops...',
                        text: 'You don not have access to this platform.'

                    });
                    toggleSignOut()
                     // doc.data() will be undefined in this case
                     console.log("No such document!");
                 }
             }).catch(function (error) {
                 console.log("Error getting document:", error);
             });
 
 
 
         } else {
             // User is signed out.
             console.log("User is signed out");
             window.location.href = 'index.html'
 
         }
 
     });
     // [END authstatelistener]
 
 }
 
 window.onload = function () {
     initApp();
 };
 
 
 
 function toggleSignOut() {
 
     // [START signout]
     firebase.auth().signOut();
     // [END signout]
 
 }
 
 $(document).on("keydown",function(e){
 
    var keyCode = e.which || e.keyCode;
    if(keyCode == 13) // enter key code
    {
       toggleSignIn();
    }
 
 });