/**
 * initApp handles setting up UI event listeners and registering Firebase auth listeners:
 *  - firebase.auth().onAuthStateChanged: This listener is called when the user is signed in or
 *    out, and that is where we update the UI.
 */

let email;
let uid;

var GET = {};
var query = window.location.search.substring(1).split("&");
for (var i = 0, max = query.length; i < max; i++) {
    if (query[i] === "") // check for trailing & with no param
        continue;

    var param = query[i].split("=");
    GET[decodeURIComponent(param[0])] = decodeURIComponent(param[1] || "");
}
let shopId = GET.shopId;
console.log("Shop Id: " + shopId);
let stName;
let stAddress;
let stEmail;
let stPhone;
let manName;
let manFname;
let manLName;
let cuisineArray;
let shopTypeArray;
let cuisineArrayIds;
let shopTypeArrayIds;
let stFloor;
let stImg;
let stOpenTime;
let stCloseTime;
let placeSearch;
let autocomplete;
let lat;
let lng;
let restAddress;
let db = firebase.firestore();

function initApp() {
    // Listening for auth state changes.
    // [START authstatelistener]
    firebase.auth().onAuthStateChanged(function (user) {
        if (user) {
            // User is signed in.

            email = user.email;
            let emailVerified = user.emailVerified;
            uid = user.uid;
            let providerData = user.providerData;

            // console.log(email)
            let db = firebase.firestore();


            let docRef = db.collection("admins").doc(uid);

            docRef.get().then(function (doc) {
                if (doc.exists) {
                    console.log("Document data:", doc.data());
                    let type = doc.data().typeId;
                    let name = doc.data().name;
                    if (type === 1) {

                        document.getElementById('proName').innerText = name;
                        db.collection("restaurants").doc(shopId).get().then(function (snapshot) {


                            stName = snapshot.data().restaurant;
                            stAddress = snapshot.data().restAddress;
                            stEmail = snapshot.data().restEmail;
                            stPhone = snapshot.data().restPhone;
                            manName = snapshot.data().managerFullName;
                            manFName = snapshot.data().managerFirstName;
                            manLName = snapshot.data().managerLastName;
                            cuisineArray = snapshot.data().cuisineTypeArray;
                            shopTypeArray = snapshot.data().restCategories;
                            cuisineArrayIds = snapshot.data().cuisineTypeIds;
                            shopTypeArrayIds = snapshot.data().restCategoriesIds;
                            stFloor = snapshot.data().restFloor;
                            stImg = snapshot.data().restImg;
                            stOpenTime = snapshot.data().openingTime;
                            stCloseTime = snapshot.data().closingTime;
                            lat = snapshot.data().latitude;
                            lng = snapshot.data().longitude;
                            restAddress  = snapshot.data().restAddress;
                            document.getElementById('shop_name').innerText = stName;
                            document.getElementById('shop_address').innerText = "Restaurant Address: " + stAddress;
                            document.getElementById('shop_floor').innerText = "Building and Floor: " + stFloor;
                            document.getElementById('shop_manager').innerText = "Manager Name: " + manName;
                            document.getElementById('shop_phone').innerText = "Restaurant Phone: " + stPhone;
                            document.getElementById('shop_email').innerText = "Restaurant Email: " + stEmail;
                            document.getElementById('shop_type').innerText = "Restaurant Type: " + shopTypeArray;
                            document.getElementById('shop_image').src = stImg;
                            document.getElementById('shop_cuisines').innerText = cuisineArray;
                            document.getElementById('shop_cuisine').innerText = "Cuisine types: " + cuisineArray;
                            document.getElementById('open_close').innerText = "Opening Time: " + stOpenTime + " Closing Time: " + stCloseTime;
                            document.getElementById('stName').value = stName;
                            document.getElementById('storeAddress').value = stAddress;
                            document.getElementById('stOpenTime').value = stOpenTime;
                            document.getElementById('stCloseTime').value= stCloseTime;
                            document.getElementById('stFloor').value = stFloor;
                            document.getElementById('stFName').value = manFName;
                            document.getElementById('stLName').value= manLName;
                            document.getElementById('stEmail').value = stEmail;
                            document.getElementById('stPhone').value = stPhone;
                            document.getElementById('imgPreview').src = stImg;
                        
                            $('#cuisineType').val(cuisineArrayIds);
                            $('#cuisineType').trigger("change");
            
                            $('#restCat').val(shopTypeArrayIds);
                            $('#restCat').trigger("change");


                        });


                    } else if (type === 2) {

                    } else if (type === 3) {

                    }


                } else {
                    Swal.fire({
                        icon: 'error',
                        title: 'Oops...',
                        text: 'You don not have access to this platform.'

                    });
                    toggleSignOut()
                    // doc.data() will be undefined in this case
                    console.log("No such document!");
                }
            }).catch(function (error) {
                console.log("Error getting document:", error);
            });



        } else {
            // User is signed out.
            console.log("User is signed out");
            window.location.href = 'index.html'

        }

    });
    // [END authstatelistener]

}
function initMap() {
    const center = { lat: 50.064192, lng: -130.605469 };
    // Create a bounding box with sides ~10km away from the center point
    const defaultBounds = {
        north: center.lat + 0.1,
        south: center.lat - 0.1,
        east: center.lng + 0.1,
        west: center.lng - 0.1,
    };
    const input = document.getElementById("storeAddress");
    const options = {
        bounds: defaultBounds,
        
        fields: ["geometry", "name"],
        origin: center,
        strictBounds: false,
        types: ["establishment"],
    };
    autocomplete = new google.maps.places.Autocomplete(input, options);
    autocomplete.addListener("place_changed", fillInAddress);
}

window.onload = function () {
    initApp();
};

function fillInAddress() {
    // Get the place details from the autocomplete object.
    const place = autocomplete.getPlace();
    console.log(place);

    lat = place.geometry.location.lat();
    // get lng
    lng = place.geometry.location.lng();
    restAddress = place.name;

    console.log(lat + " " + lng + " " + restAddress);
}
$(document).ready(function () {
    $("#restCat").select2();
    $("#cuisineType").select2();
    let imFile = document.getElementById("findPhoto");
    let imPreview = document.getElementById("imgPreview");
    imFile.onchange = evt => {
        file = imFile.files[0]
        if (file) {
            imPreview.src = URL.createObjectURL(file)
        }
    }
});




function toggleSignOut() {

    // [START signout]
    firebase.auth().signOut();
    // [END signout]

}

$(document).on("keydown", function (e) {

    var keyCode = e.which || e.keyCode;
    if (keyCode == 13) // enter key code
    {
        toggleSignIn();
    }

});

function generateUUID() { // Public Domain/MIT
    var d = new Date().getTime();//Timestamp
    var d2 = (performance && performance.now && (performance.now() * 1000)) || 0;//Time in microseconds since page-load or 0 if unsupported
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = Math.random() * 16;//random number between 0 and 16
        if (d > 0) {//Use timestamp until depleted
            r = (d + r) % 16 | 0;
            d = Math.floor(d / 16);
        } else {//Use microseconds since page-load if supported
            r = (d2 + r) % 16 | 0;
            d2 = Math.floor(d2 / 16);
        }
        return (c === 'x' ? r : (r & 0x3 | 0x8)).toString(16);
    });
}


function openDetails(id) {

    window.location.href = "shop_details.html?shopId=" + id

}