/**
 * initApp handles setting up UI event listeners and registering Firebase auth listeners:
 *  - firebase.auth().onAuthStateChanged: This listener is called when the user is signed in or
 *    out, and that is where we update the UI.
 */

 let email;
 let uid;
 
 
 function initApp() {
     // Listening for auth state changes.
     // [START authstatelistener]
     firebase.auth().onAuthStateChanged(function (user) {
         if (user) {
             // User is signed in.
 
             email = user.email;
             let emailVerified = user.emailVerified;
             uid = user.uid;
             let providerData = user.providerData;
 
             // console.log(email)
             let db = firebase.firestore();
 
 
             let docRef = db.collection("admins").doc(uid);
 
             docRef.get().then(function (doc) {
                 if (doc.exists) {
                     console.log("Document data:", doc.data());
                     let type = doc.data().typeId;
                     let name = doc.data().name;
                     if (type === 1) {
                    
                         document.getElementById('proName').innerText = name;
                         db.collection("restaurants").orderBy('timestamp', 'desc').get().then(function (snapshot) {
                            snapshot.forEach(function (document) {
                                
                                let stName = document.data().restaurant;
                                let stAddress = document.data().restAddress;
                                let stEmail = document.data().restEmail;
                                let stPhone = document.data().restPhone;
                               
            
                                var body = "<tr>";

                                body += "<td>" + stName + "</td>";
                                body += "<td>" + stAddress + "</td>";
                                body += "<td>" + stPhone + "</td>";
                                body += "<td>" + stEmail + "</td>";
                                body += '<td><div class="row card-body"><button  id=' + document.id + ' class="btn btn-primary"  onclick ="openDetails(this.id)">View/Edit</button><button  id=' + document.id + ' class="btn btn-danger" data-toggle="modal" data-target="#exampleModalform5" onclick ="deleteCat(this.id)">Disable</button></div></td>';
                                body += "</tr>"
                                $("#shops tbody").append(body);
                            });
                            $('#shops').DataTable( {
                                dom: 'Bfrtip',
                                buttons: [
                                    'copy', 'csv', 'excel', 'pdf', 'print'
                                ]
                            } );
                        });
                     }else if(type === 2){
                         
                     } else if (type === 3) {
                         
                     }
 
 
                 } else {
                    Swal.fire({
                        icon: 'error',
                        title: 'Oops...',
                        text: 'You don not have access to this platform.'

                    });
                    toggleSignOut()
                     // doc.data() will be undefined in this case
                     console.log("No such document!");
                 }
             }).catch(function (error) {
                 console.log("Error getting document:", error);
             });
 
 
 
         } else {
             // User is signed out.
             console.log("User is signed out");
             window.location.href = 'index.html'
 
         }
 
     });
     // [END authstatelistener]
 
 }
 
 window.onload = function () {
     initApp();
 };
 
 
 
 function toggleSignOut() {
 
     // [START signout]
     firebase.auth().signOut();
     // [END signout]
 
 }
 
 $(document).on("keydown",function(e){
 
    var keyCode = e.which || e.keyCode;
    if(keyCode == 13) // enter key code
    {
       toggleSignIn();
    }
 
 });


 function openDetails(id) {
 
    window.location.href = "shop_details.html?shopId="+id

}